/*###########################################################################
#                                                                           #
#    		         777 TOWN.net XbgpRg[                    #
# V-USB																		#
# http://www.obdev.at/products/vusb/index.html								#
# t@XvWFNguHIDKeys - a USB Keyboardvtiny2313ɈڐA		#
# őłPR̃L[͂ł											#
#                                                                           #
# V-USB̃t[VID(0x16c0) / PID(0x27db)gpĂB					#
# V-USB@gpĂꍇIDdĂȂC邱		#
#                                                                           #
# RpCF WinAVR-20100110                                          #
#                  AVR Studio 4.18 build 715                                #
#                  vusb-20100715                                            #
# RpC̃o[WɂẮAvOR[h2048𒴂		#
#																			#
###########################################################################*/
#define __MAIN_C__
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#include "vusb/usbdrv/usbdrv.h"
#include "keys.h"

#define NUM_KEYS 13			/* ǗL[(tiny2313̎gp\|[g)		*/
							/* AVȐꍇ͂Ƒ傫Ȓlwł	*/

/*****************************************************************************
*				L[ԍHIDhCopL[R[hϊe[u
*****************************************************************************/
const PROGMEM  uint8_t keyReport[ NUM_KEYS + 1 ][ 2 ] = {
	 { MOD_NON_KEY  ,KEY_NON	}		/* ŒliύXsj				*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB0̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB1̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB2̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB3̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB4̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB5̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB6̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_NON	}		/* PB7̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY	,KEY_NON	}		/* PD0̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_RIGHT	}		/* PD3̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_DOWN	}		/* PD4̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_LEFT	}		/* PD5̃XCb`ւ̊蓖ăR[h	*/
	,{ MOD_NON_KEY 	,KEY_SPACE	}		/* PD6̃XCb`ւ̊蓖ăR[h	*/
};

/*****************************************************************************
*							USB report descriptor
*****************************************************************************/
PROGMEM char usbHidReportDescriptor[35] = {
	0x05 ,0x01,				/* USAGE_PAGE (Generic Desktop)					*/
	0x09 ,0x06,				/* USAGE (Keyboard)								*/
	0xa1 ,0x01,				/* COLLECTION (Application)						*/
	0x05 ,0x07,				/* USAGE_PAGE (Keyboard)						*/
	0x19 ,0xe0,				/* USAGE_MINIMUM (Keyboard LeftControl)			*/
	0x29 ,0xe7,				/* USAGE_MAXIMUM (Keyboard Right GUI)			*/
	0x15 ,0x00,				/* LOGICAL_MINIMUM (0)							*/
	0x25 ,0x01,				/* LOGICAL_MAXIMUM (1)							*/
	0x75 ,0x01,				/* REPORT_SIZE (1)								*/
	0x95 ,0x08,				/* REPORT_COUNT (8)								*/
	0x81 ,0x02,				/* INPUT (Data,Var,Abs)							*/
	0x95 ,0x01,				/* REPORT_COUNT (1)								*/
	0x75 ,0x08,				/* REPORT_SIZE (8)								*/
	0x25 ,0x65,				/* LOGICAL_MAXIMUM (101)						*/
	0x19 ,0x00,				/* USAGE_MINIMUM (Reserved (no event indicated)	*/
	0x29 ,0x65,				/* USAGE_MAXIMUM (Keyboard Application)			*/
	0x81 ,0x00,				/* INPUT (Data,Ary,Abs)							*/
	0xc0					/* END_COLLECTION								*/
};

/*****************************************************************************
*						W[[Jϐ錾
*****************************************************************************/
volatile static uint8_t reportBuffer[2];	/* buffer for HID reports		*/
volatile static uint8_t idleRate = 0;		/* in 4 ms units				*/
volatile static uint8_t lastKey  = 0;		/* last button number			*/

/*****************************************************************************
*						Ă{^ԍ擾
* Fvoid
* ߒlFuint8_t 0:ĂȂ
*               1:ĂL[ԍ
*****************************************************************************/
static uint8_t keyPressed( void )
{
	static uint8_t index = 0;				/* Ή̈			*/

	uint8_t i = index;
	uint8_t key = 0;
	uint8_t bit;

	do {
		if ( i < 8 ) {						/* PB0`7`FbN				*/
			bit = 1 << i;
			if ( ( PINB & bit ) == 0x00 ) {
				key = i + 1;
			}

		} else {
			if ( i == 8 ) {					/* PD0`FbN					*/
				if ( ( PIND & 0x01 ) == 0x00 ) {
					key = i + 1;
				}

			} else {
				bit = 1 << ( i - 6 );		/* PD4`PD6 `FbN			*/
				if ( ( PIND & bit ) == 0x00 ) {
					key = i + 1;
				}
			}
		}

		if ( ++i >= NUM_KEYS ) i = 0;
	} while ( ( index != i ) && ( key == 0 ) );

	index = i;

	return ( key );
}

/*****************************************************************************
*								n[hEGA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	ACSR = _BV(ACD);						/* AiORp[^d͒~	*/

	/* 	PortB +--------7: Pullup : Key8                                     */
	/*        |+-------6: Pullup : Key7                                     */
	/*        ||+------5: Pullup : Key6                                     */
	/*        |||+-----4: Pullup : Key5                                     */
	/*        ||||+----3: Pullup : Key4                                     */
	/*        |||||+---2: Pullup : Key3                                     */
	/*        ||||||+--1: Pullup : Key2                                     */
	/*        |||||||+-0: Pullup : Key1                                     */
	DDRB  = 0b00000000;
	PORTB = 0b11111111;

	/* 	PortD +--------7: Pullup : -----                                    */
	/*        |+-------6: Pullup : Key13                                    */
	/*        ||+------5: Pullup : Key12                                    */
	/*        |||+-----4: Pullup : Key11                                    */
	/*        ||||+----3: Pullup : Key10                                    */
	/*        |||||+---2: Pullup : USB D-                                   */
	/*        ||||||+--1: Low    : USB D+                                   */
	/*        |||||||+-0: Pullup : Key9                                     */
	DDRD  = 0b00000100;
	PORTD = 0b01111011;

	/* 10msecȏ̑҂		*/
	uint8_t i = 10;
	while ( i-- ) {
		_delay_ms( 1 );
	}

	/* USB|[gݒ		*/
	/* PD1:USB D- HI-Z		*/
	/* PD2:USB D+ HI-Z		*/
	DDRD  &= 0b01111001;
	PORTD &= 0b01111001;

	/* timer0(8bit)	*/
	TCCR0B = 0x05;				/* 12MHz / 1024 * 256 = 45.78Hz(22msec)	*/
	TCNT0  = 0;
}

/*****************************************************************************
*						w̃{^ԍUSB|[gf[^쐬
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void buildReport( uint8_t key )
{
	*(uint16_t *)reportBuffer = pgm_read_word( keyReport[key] );
}

/*****************************************************************************
*								USBZbgAbv
* Fuchar data[8]
* ߒlFUSB_PUBLIC uchar 
*****************************************************************************/
USB_PUBLIC uchar usbFunctionSetup( uchar data[8] )
{
	uchar ret = 0;
	usbMsgPtr = (uchar *)reportBuffer;
	usbRequest_t *rq = (usbRequest_t *)data;

	if ( ( rq->bmRequestType & USBRQ_TYPE_MASK ) == USBRQ_TYPE_CLASS ) {	/* class request type					*/

		if ( rq->bRequest == USBRQ_HID_GET_REPORT ) {	/* wValue: ReportType (highbyte), ReportID (lowbyte)		*/
			buildReport( lastKey );						/* we only have one report type, so don't look at wValue	*/
			ret = sizeof(reportBuffer);

		} else if ( rq->bRequest == USBRQ_HID_GET_IDLE ) {
			usbMsgPtr = (uint8_t *)&idleRate;
			ret = 1;

		} else if ( rq->bRequest == USBRQ_HID_SET_IDLE ) {
			idleRate = rq->wValue.bytes[1];
		}
	}

	return ( ret );
}

/*****************************************************************************
*							C
* Fvoid
* ߒlFint 
*****************************************************************************/
int	main( void )
{
	/* ϐ錾									*/
	uint8_t key = 0;						/* {^ԕۑ			*/
	uint8_t keyDidChange = 1;				/* {^ԕωtO		*/
	uint8_t idleCounter = 0;				/* 22 ms in units of 4 ms		*/

	/* EIb`hbN						*/
	wdt_enable( WDTO_250MS );

	/* n[hEGA						*/
	hardwareInit();
	wdt_reset();

	/* AVR-USB							*/
	usbInit();
	wdt_reset();

	/* O[oC^vg				*/
	sei();

	/* C[v								*/
	while ( 1 ) {

		/* EIb`hbNZbg				*/
		wdt_reset();

		/* AVR-USB |[O					*/
		usbPoll();

		/* 22msec^C}[						*/
		if ( TIFR & _BV(TOV0) ) {
			TIFR = _BV(TOV0);

			if ( !keyDidChange ) {							/* {^Ԏ擾			*/
				if ( ( key = keyPressed() ) != lastKey ) {	/* OƈႦΕύXLtOON	*/
					lastKey = key;
					keyDidChange = 1;
				}
			}

			if ( idleRate != 0 ) {
				if ( idleCounter > 4 ) {
					idleCounter -= 5;						/* 22 ms in units of 4 ms		*/
				} else {
					idleCounter = idleRate;
					keyDidChange = 1;
				}
			}
		}

		/* ԕω & USBM\̏	*/
		if ( keyDidChange && usbInterruptIsReady() ) {
			buildReport( lastKey );
			usbSetInterrupt( (uint8_t *)reportBuffer, sizeof(reportBuffer) );
			keyDidChange = 0;
		}
	}

	return ( 0 );
}

